/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Servlets;

import DataBase.DBAuthor;
import java.io.IOException;
import java.sql.Date;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author vasena
 */
@WebServlet(name = "Author", urlPatterns = {"/Author"})
public class Author extends HttpServlet {

    DBAuthor dbAuthor;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbAuthor = (DBAuthor) config.getServletContext().getAttribute("dbAuthor");
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("add", false);
        request.setAttribute("update", false);
        request.setAttribute("result", 0);
        if (request.getParameter("add") != null) {
            request.setAttribute("add", true);
            doAddAuthor(request, response);
        }
        if (request.getParameter("update") != null) {
            request.setAttribute("update", true);
            request.setAttribute("ID", Integer.parseInt(request.getParameter("ID")));
            doUpdateAuthor(request, response);
        }
         if (request.getParameter("delete") != null) {
            doDeleteAuthor(request, response);
        }
        request.setAttribute("AuthorList", dbAuthor.LoadList());
        this.getServletContext().getRequestDispatcher("/Author.jsp").forward(request, response);
    }

    protected void doAddAuthor(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Name = request.getParameter("NAME");
        String Surname = request.getParameter("SURNAME");
        String Year = request.getParameter("YEAR");
        if (Name == null || Surname == null || Year == null) {
            return;
        }
        request.setAttribute("result", 1);
        try {
            dbAuthor.addAuthor(Name, Surname, Date.valueOf(Year));
        } catch (Exception e) {
            request.setAttribute("result", -1);
        }
    }

    protected void doUpdateAuthor(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("ID");
        String Name = request.getParameter("NAME");
        String Surname = request.getParameter("SURNAME");
        String Year = request.getParameter("YEAR");
        if (ID == null || Name == null || Surname == null || Year == null) {
            return;
        }
        request.setAttribute("result", 2);
        try {
            dbAuthor.updateAuthor(Integer.parseInt(ID), Name, Surname, Date.valueOf(Year));
        } catch (Exception e) {
            request.setAttribute("result", -2);
        }
    }

    protected void doDeleteAuthor(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("ID");
        if (ID == null) {
            return;
        }
        request.setAttribute("result", 3);
        try {
            dbAuthor.deleteAuthor(Integer.parseInt(ID));
        } catch (Exception e) {
            request.setAttribute("result", -3);
        }
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">

    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Author.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Author.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
