/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Servlets;

import DataBase.DBAuthor;
import DataBase.DBBook;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author vasena
 */
@WebServlet(name="Book", urlPatterns={"/Book"})
public class Book extends HttpServlet {
    
    DBBook dbBook;
    DBAuthor dbAuthor;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbBook = (DBBook) config.getServletContext().getAttribute("dbBook");
        dbAuthor = (DBAuthor) config.getServletContext().getAttribute("dbAuthor");
    }
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("add", false); 
        request.setAttribute("update", false); 
        request.setAttribute("result", 0);
        if (request.getParameter("add")!=null)
        {
           request.setAttribute("add", true); 
           doAddBook(request, response);
        }
        if (request.getParameter("update")!=null)
        {
           request.setAttribute("update", true); 
           request.setAttribute("ID", Integer.parseInt(request.getParameter("ID")));
           doUpdateBook(request, response);
        }
        if (request.getParameter("delete")!=null)
        {
           doDeleteBook(request, response);
        }
        request.setAttribute("BookList", dbBook.LoadList());
        request.setAttribute("AuthorList", dbAuthor.LoadList());
        this.getServletContext().getRequestDispatcher("/Book.jsp").forward(request, response);
    } 
    
     protected void doAddBook(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
         String ID_Author = request.getParameter("ID_AUTHOR");
        String Title = request.getParameter("TITLE");
        String Publisher = request.getParameter("PUBLISHER");
        String Pages = request.getParameter("PAGES");
        String Year = request.getParameter("YEAR");
        if (ID_Author == null ||  Title  == null || Publisher == null || Pages == null ||  Year  == null) {
            return;
        }
        request.setAttribute("result", 1);
        try {
            dbBook.addBook(Integer.parseInt(ID_Author),Title,Publisher,Integer.parseInt(Pages),Integer.parseInt(Year));
        } catch (Exception e) {
            request.setAttribute("result", -1);
        }
    }

    protected void doUpdateBook(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("ID");
        String ID_Author = request.getParameter("ID_AUTHOR");
        String Title = request.getParameter("TITLE");
        String Publisher = request.getParameter("PUBLISHER");
        String Pages = request.getParameter("PAGES");
        String Year = request.getParameter("YEAR");
        if (ID == null ||ID_Author == null ||  Title  == null || Publisher == null || Pages == null ||  Year  == null) {
            return;
        }
        request.setAttribute("result", 2);
        try {
            dbBook.updateBook(Integer.parseInt(ID),Integer.parseInt(ID_Author),Title,Publisher,Integer.parseInt(Pages),Integer.parseInt(Year));
        } catch (Exception e) {
            request.setAttribute("result", -2);
        }
    }

    protected void doDeleteBook(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("ID");
        if (ID == null) {
            return;
        }
        request.setAttribute("result", 3);
        try {
            dbBook.deleteBook(Integer.parseInt(ID));
        } catch (Exception e) {
            request.setAttribute("result", -3);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Book.class.getName()).log(Level.SEVERE, null, ex);
        }
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Book.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
