/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Servlets;

import DataBase.DBCatalog;
import Objects.CCatalog;
import java.io.IOException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Vasena
 */
@WebServlet(name = "Catalog", urlPatterns = {"/Catalog"})
public class Catalog extends HttpServlet {

    DBCatalog dbCatalog;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbCatalog = (DBCatalog) config.getServletContext().getAttribute("dbCatalog");
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("add", false);
        request.setAttribute("update", false);
        request.setAttribute("view", false);
        request.setAttribute("result", 0);
        if (request.getParameter("add") != null) {
            request.setAttribute("add", true);
            request.setAttribute("stage", 1);
            doAddCatalog(request, response);
        }
        if (request.getParameter("update") != null) {
            request.setAttribute("update", true);
            CCatalog obj = dbCatalog.getCatalog(Integer.parseInt(request.getParameter("ID")), dbCatalog.LoadList());
            request.setAttribute("Title", obj.getTITLE());
            request.setAttribute("BookList", dbCatalog.getBookList(obj.getID(), obj.getID_PARENT()));
            request.setAttribute("CatalogBookList", dbCatalog.getBookList(obj.getID()));
            doUpdateCatalog(request, response);
        }
        if (request.getParameter("delete") != null) {
            doDeleteCatalog(request, response);
        }
         if (request.getParameter("view") != null) {
            request.setAttribute("view", true);
            CCatalog obj = dbCatalog.getCatalog(Integer.parseInt(request.getParameter("ID")), dbCatalog.LoadList());
            request.setAttribute("Title", obj.getTITLE());
            request.setAttribute("CatalogBookList", dbCatalog.getBookList(obj.getID()));
        }
        request.setAttribute("CatalogList", dbCatalog.LoadList());
        this.getServletContext().getRequestDispatcher("/Catalog.jsp").forward(request, response);
    }

    protected void doAddCatalog(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID_Parent = request.getParameter("ID_PARENT");
        String Title = request.getParameter("TITLE");
        String ID_Books[] = request.getParameterValues("ID_BOOKS");
        if (ID_Parent != null && Title != null) {
            request.setAttribute("result", 1);
            try {
                request.setAttribute("stage", 2);
                dbCatalog.addCatalog(Integer.parseInt(ID_Parent), Title);
                request.setAttribute("Title", Title);
                request.setAttribute("BookList", dbCatalog.getBookList(Integer.parseInt(ID_Parent)));
            } catch (Exception e) {
                request.setAttribute("result", -1);
            }
        }
        if (ID_Books != null) {
            request.setAttribute("result", 2);
            try {
                for (int i = 0; i < ID_Books.length; i++) {
                    dbCatalog.addBook(Integer.parseInt(ID_Books[i]));
                }
            } catch (Exception e) {
                request.setAttribute("result", -2);
            }
        }
    }

    protected void doUpdateCatalog(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID_BooksAdd[] = request.getParameterValues("ID_BOOKS_ADD");
        String ID_BooksRemove[] = request.getParameterValues("ID_BOOKS_REMOVE");
        String ID = request.getParameter("ID");
        int result = 0;
        if (ID_BooksAdd != null) {
            result += 1;
            try {
                for (int i = 0; i < ID_BooksAdd.length; i++) {
                    dbCatalog.addBook(Integer.parseInt(ID_BooksAdd[i]), Integer.parseInt(ID));
                }
            } catch (Exception e) {
                result = -2;
            }
        }
        if (ID_BooksRemove != null) {
            result += 1;
            try {
                for (int i = 0; i < ID_BooksRemove.length; i++) {
                    dbCatalog.removeBook(Integer.parseInt(ID_BooksRemove[i]), Integer.parseInt(ID));
                }
            } catch (Exception e) {
                result = -2;
            }
        }
        if (result < 0) {
            result = -2;
        }
        if (result > 0) {
            result = 2;
        }
        request.setAttribute("result", result);
    }

    protected void doDeleteCatalog(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("ID");
        if (ID == null) {
            return;
        }
        request.setAttribute("result", 3);
        try {
            dbCatalog.deleteCatalog(Integer.parseInt(ID));
        } catch (Exception e) {
            request.setAttribute("result", -3);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Catalog.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Catalog.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
