/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Servlets;

import DataBase.DBUser;
import Objects.CUser;
import java.io.IOException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Vasena
 */
@WebServlet(name = "Main", urlPatterns = {"/Index"})
public class Main extends HttpServlet {

    DBUser dbUser;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbUser = (DBUser) config.getServletContext().getAttribute("dbUser");
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("result", 0);
        request.setAttribute("register", false);
        request.setAttribute("login", false);
        if (request.getParameter("logout") != null) {
            request.getSession().setAttribute("User", new CUser());
        }
        if (request.getParameter("login") != null) {
            request.setAttribute("login", true);
            doLogin(request, response);
        }
        if (request.getParameter("register") != null) {
            request.setAttribute("register", true);
            request.setAttribute("LOGIN", "");
            doRegister(request, response);
        }
        if (request.getSession().getAttribute("User") == null) {
            request.getSession().setAttribute("User", new CUser());
        }
        this.getServletContext().getRequestDispatcher("/index.jsp").forward(request, response);
    }

    protected void doLogin(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Login = request.getParameter("LOGIN");
        String Password = request.getParameter("PASSWORD");
        if (Login != null && Password != null) {
            CUser User = dbUser.getUser(Login, Password);
            if (User != null) {
                request.getSession().setAttribute("User", User);
                request.setAttribute("login", false);
            } else {
                request.setAttribute("result", -1);
            }
        }

    }

    protected void doRegister(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Login = request.getParameter("LOGIN");
        String Password = request.getParameter("PASSWORD");
        if (Login != null && Password != null) {
            if (Login.isEmpty() || Password.isEmpty()) {
                request.setAttribute("result", -3);
                request.setAttribute("LOGIN", Login);
                return;
            }
            if (dbUser.addUser(Login, Password)) {
                request.setAttribute("result", 2);
                request.setAttribute("register", false);
            } else {
                request.setAttribute("result", -2);
                request.setAttribute("LOGIN", Login);
            }
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException,
            IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException,
            IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
