/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Servlets;

import DataBase.DBBook;
import DataBase.DBProperty;
import Objects.CBook;
import java.io.IOException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Vasena
 */
@WebServlet(name = "Property", urlPatterns = {"/Property"})
public class Property extends HttpServlet {

    DBProperty dbProperty;
    DBBook dbBook;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbProperty = (DBProperty) config.getServletContext().getAttribute("dbProperty");
        dbBook = (DBBook) config.getServletContext().getAttribute("dbBook");
    }

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("add", false);
        request.setAttribute("update", false);
        request.setAttribute("result", 0);
        if (request.getParameter("add") != null) {
            request.setAttribute("add", true);
            doAddProperty(request, response);
            String ID_Book = request.getParameter("ID_BOOK");
            if (ID_Book != null) {
                request.setAttribute("aPropertyList", dbProperty.LoadAList(Integer.parseInt(ID_Book)));
            }
        }
        if (request.getParameter("update") != null) {
            request.setAttribute("update", true);
            if (request.getParameter("ID_BOOK") == null) {
                request.setAttribute("ID_PROPERTY", Integer.parseInt(request.getParameter("ID_PROPERTY")));
            } else {
                request.setAttribute("ID", Integer.parseInt(request.getParameter("ID")));
            }
            doUpdateProperty(request, response);
        }
        if (request.getParameter("delete") != null) {
            doDeleteroperty(request, response);
        }
        try {
            String ID_Book = request.getParameter("ID_BOOK");
            if (ID_Book == null) {
                throw new GotoException();
            }
            CBook Book = dbBook.getBook(Integer.parseInt(ID_Book), dbBook.LoadList());
            if (Book == null) {
                throw new GotoException();
            }
            request.setAttribute("Book", Book);
            request.setAttribute("PropertyList", dbProperty.LoadBookList(Integer.parseInt(ID_Book)));
        } catch (GotoException e) {
            request.setAttribute("Book", null);
            request.setAttribute("PropertyList", dbProperty.LoadList());
        }
        this.getServletContext().getRequestDispatcher("/Property.jsp").forward(request, response);
    }

    protected void doAddProperty(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Title = request.getParameter("TITLE");
        String ID_Property = request.getParameter("ID_PROPERTY");
        String ID_Book = request.getParameter("ID_BOOK");
        String Value = request.getParameter("VALUE");
        if (Title != null) {
            request.setAttribute("result", 1);
            try {
                dbProperty.addProperty(Title);
            } catch (Exception e) {
                request.setAttribute("result", -1);
            }
        }
        if (ID_Property != null && ID_Book != null && Value != null) {
            request.setAttribute("result", 1);
            try {
                dbProperty.addProperty(Integer.parseInt(ID_Property), Integer.parseInt(ID_Book), Value);
            } catch (Exception e) {
                request.setAttribute("result", -1);
            }
        }
    }

    protected void doUpdateProperty(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID_Property = request.getParameter("ID_PROPERTY");
        String Title = request.getParameter("TITLE");
        String ID = request.getParameter("ID");
        String Value = request.getParameter("VALUE");
        if (ID_Property != null && Title != null) {
            request.setAttribute("result", 2);
            try {
                dbProperty.updateProperty(Integer.parseInt(ID_Property), Title);
            } catch (Exception e) {
                request.setAttribute("result", -2);
            }
        }
        if (ID != null && Value != null) {
            request.setAttribute("result", 2);
            try {
                dbProperty.updateValue(Integer.parseInt(ID), Value);
            } catch (Exception e) {
                request.setAttribute("result", -2);
            }
        }
    }

    protected void doDeleteroperty(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID_Property = request.getParameter("ID_PROPERTY");
        String ID = request.getParameter("ID");
        if (ID_Property != null) {
            request.setAttribute("result", 3);
            try {
                dbProperty.deleteProperty(Integer.parseInt(ID_Property));
            } catch (Exception e) {
                request.setAttribute("result", -3);
            }
        }
        if (ID != null) {
            request.setAttribute("result", 3);
            try {
                dbProperty.deleteBookProperty(Integer.parseInt(ID));
            } catch (Exception e) {
                request.setAttribute("result", -3);
            }
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);



        } catch (SQLException ex) {
            Logger.getLogger(Property.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);



        } catch (SQLException ex) {
            Logger.getLogger(Property.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";



    }// </editor-fold>
}

class GotoException extends Exception {
}
