/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Servlets;

import DataBase.*;
import java.io.IOException;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Vasena
 */
public class SearchServlet extends HttpServlet {

    DBAuthor dbAuthor;
    DBCatalog dbCatalog;
    DBBook dbBook;
    DBProperty dbProperty;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        dbAuthor = (DBAuthor) config.getServletContext().getAttribute("dbAuthor");
        dbCatalog = (DBCatalog) config.getServletContext().getAttribute("dbCatalog");
        dbBook = (DBBook) config.getServletContext().getAttribute("dbBook");
        dbProperty = (DBProperty) config.getServletContext().getAttribute("dbProperty");
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        request.setAttribute("stage", 0);
        String sstage = request.getParameter("stage");
        if (sstage != null) {
            byte stage = Byte.valueOf(sstage);
            switch (stage) {
                case 1:
                    request.setAttribute("stage", 1);
                    searchAuthor(request, response);
                    break;
                case 2:
                    request.setAttribute("stage", 2);
                    setAuthor(request, response);
                    request.setAttribute("CatalogList", dbCatalog.LoadList());
                    break;
                case 3:
                    request.setAttribute("stage", 3);
                    setAuthor(request, response);
                    setCatalog(request, response);
                    break;
                case 4:
                    request.setAttribute("stage", 4);
                    setAuthor(request, response);
                    setCatalog(request, response);
                    searchBook(request, response);
                    break;
                case 5:
                    request.setAttribute("stage", 5);
                    setAuthor(request, response);
                    setCatalog(request, response);
                    setBook(request, response);
                    break;
            }
        }
        this.getServletContext().getRequestDispatcher("/SearchPage.jsp").forward(request, response);
    }

    protected void searchAuthor(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Name = null, Surname = null;
        String flag = request.getParameter("AuthorNameFlag");
        if (flag != null) {
            Name = request.getParameter("AuthorName");
            if (Name == null) {
                request.setAttribute("stage", 0);
                return;
            }
        }
        flag = request.getParameter("AuthorSurnameFlag");
        if (flag != null) {
            Surname = request.getParameter("AuthorSurname");
            if (Surname == null) {
                request.setAttribute("stage", 0);
                return;
            }
        }
        if (Name == null && Surname == null) {
            request.setAttribute("stage", 0);
            return;
        }
        request.setAttribute("result", 1);
        List AuthorList = null;
        try {
            AuthorList = dbAuthor.searchAuthor(Name, Surname);
            if (AuthorList.isEmpty()) {
                request.setAttribute("result", 0);
            }
        } catch (Exception e) {
            request.setAttribute("result", -1);
            request.setAttribute("stage", 0);
        }
        request.setAttribute("AuthorList", AuthorList);
    }

    protected void setAuthor(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("Author_ID");
        if (ID == null) {
            return;
        }
        try {
            request.setAttribute("Author", dbAuthor.getAuthor(Integer.parseInt(ID)));
        } catch (Exception e) {
        }

    }

    protected void setCatalog(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("Catalog_ID");
        if (ID == null) {
            return;
        }
        try {
            request.setAttribute("Catalog", dbCatalog.getCatalog(Integer.parseInt(ID), dbCatalog.LoadList()));
        } catch (Exception e) {
        }

    }

    protected void searchBook(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String Title = null, Publisher = null, Pages=null, Year=null, Condition;
        String ID_Author = request.getParameter("Author_ID");
        String ID_Catalog = request.getParameter("Catalog_ID");
        if (ID_Catalog==null){
            request.setAttribute("result", -2);
            request.setAttribute("stage", 3);
            return;
        }
        String flag = request.getParameter("BookTitleFlag");
        if (flag != null) {
            Title = request.getParameter("BookTitle");
            if (Title == null) {
                request.setAttribute("stage", 3);
                return;
            }
        }
        flag = request.getParameter("BookPublisherFlag");
        if (flag != null) {
            Publisher = request.getParameter("BookPublisher");
            if (Publisher == null) {
                request.setAttribute("stage", 3);
                return;
            }
        }
        flag = request.getParameter("BookPagesFlag");
        if (flag != null) {
            Condition=request.getParameter("BookPagesCondition");
            if (Condition == null) {
                request.setAttribute("stage", 3);
                return;
            }
            Pages = request.getParameter("BookPages");
            if (Pages == null) {
                request.setAttribute("stage", 3);
                return;
            }
            Pages=Condition+Pages;
        }
        flag = request.getParameter("BookYearFlag");
        if (flag != null) {
            Condition=request.getParameter("BookYearCondition");
            if (Condition == null) {
                request.setAttribute("stage", 3);
                return;
            }
            Year = request.getParameter("BookYear");
            if (Year == null) {
                request.setAttribute("stage", 3);
                return;
            }
            Year=Condition+Year;
        }
        request.setAttribute("result", 2);
        List BookList = null;
        try {
            BookList = dbBook.searchBook(Title, Publisher, Pages, Year, ID_Catalog, ID_Author);
            if (BookList.isEmpty()) {
                request.setAttribute("result", 0);
            }
        } catch (Exception e) {
            request.setAttribute("result", -2);
            request.setAttribute("stage", 3);
        }
        request.setAttribute("ResultList", BookList);
    }
    
    protected void setBook(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, SQLException {
        String ID = request.getParameter("Book_ID");
        if (ID == null) {
            return;
        }
        try {
            request.setAttribute("Book", dbBook.getBook(Integer.parseInt(ID), dbBook.LoadList()));
        } catch (Exception e) {
        }
        try {
            request.setAttribute("PropertyList", dbProperty.LoadBookList(Integer.parseInt(ID)));
        } catch (Exception e) {
        }

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(SearchServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (SQLException ex) {
            Logger.getLogger(SearchServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
